#
#    DBD::Teradata = Perl DBI Driver for Teradata
#    Copyright (C) 2001-2009, Presicient Corp., USA
#    email: info@presicient.com
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; Refer to the included LICENSE file, or the LICENSE section 
#    of the DBD::Teradata documentation, for details. If neither is available,
#    write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
#
# The %info hash was automatically generated by
# DBI::DBD::Metadata::write_getinfo_pm v1.05.

package DBD::Teradata::GetInfo;

use strict;
use DBD::Teradata;

# Beware: not officially documented interfaces...
# use DBI::Const::GetInfoType qw(%GetInfoType);
# use DBI::Const::GetInfoReturn qw(%GetInfoReturnTypes %GetInfoReturnValues);

my $sql_driver = 'Teradata';
my $sql_driver_ver = '8.101';

my @Keywords = qw(

ABORT
ABORTSESSION
ABS
ACCESS
ACCESS_LOCK
ACCOUNT
ACOS
ACOSH
ADD_MONTHS
ADMIN
AFTER
AGGREGATE
ALIAS
ALLOCATION
ALWAYS
AMP
ANALYSIS
ANSIDATE
ASCII
ASIN
ASINH
ATAN
ATAN2
ATANH
ATOMIC
ATTR
ATTRIBUTES
ATTRS
AVE
AVERAGE
BEFORE
BLOB
BT
BUT
BYTE
BYTEINT
BYTES
CALL
CALLED
CASESPECIFIC
CASE_N
CD
CHANGERATE
CHAR2HEXINT
CHARACTERS
CHARS
CHARSET_COLL
CHECKPOINT
CHECKSUM
CLASS
CLOB
CLUSTER
CM
COLLECT
COLUMNSPERINDEX
COMMENT
COMPRESS
CONVERT_TABLE_HEADER
CORR
COS
COSH
COSTS
COVAR_POP
COVAR_SAMP
CS
CSUM
CT
CUBE
CV
CYCLE
DATA
DATABASE
DATABLOCKSIZE
DATEFORM
DBC
DEGREES
DEL
DEMOGRAPHICS
DENIALS
DETERMINISTIC
DIAGNOSTIC
DIGITS
DISABLED
DO
DUAL
DUMP
EACH
EBCDIC
ECHO
ELSEIF
ENABLED
EQ
ERROR
ERRORFILES
ERRORTABLES
ET
EXCL
EXCLUSIVE
EXIT
EXP
EXPIRE
EXPLAIN
FALLBACK
FASTEXPORT
FOLLOWING
FORMAT
FREESPACE
FUNCTION
GE
GENERATED
GIVE
GRAPHIC
GROUPING
GT
HANDLER
HASH
HASHAMP
HASHBAKAMP
HASHBUCKET
HASHROW
HELP
HIGH
HOST
IF
IFP
INCONSISTENT
INCREMENT
INDEXESPERTABLE
INITIATE
INOUT
INS
INSTEAD
INTEGERDATE
ITERATE
JIS_COLL
JOURNAL
KANJI1
KANJISJIS
KBYTE
KBYTES
KEEP
KILOBYTES
KURTOSIS
LATIN
LE
LEAVE
LIMIT
LN
LOADING
LOCATOR
LOCK
LOCKEDUSEREXPIRE
LOCKING
LOG
LOGGING
LOGON
LONG
LOOP
LOW
LT
MACRO
MATCHED
MAVG
MAXCHAR
MAXIMUM
MAXLOGONATTEMPTS
MAXVALUE
MCHARACTERS
MDIFF
MEDIUM
MERGE
MINCHAR
MINDEX
MINIMUM
MINUS
MINVALUE
MLINREG
MLOAD
MOD
MODE
MODIFIED
MODIFY
MONITOR
MONRESOURCE
MONSESSION
MSUBSTR
MSUM
MULTINATIONAL
MULTISET
NAME
NAMED
NE
NEW
NEW_TABLE
NOWAIT
NULLIFZERO
OBJECTS
OFF
OLD
OLD_TABLE
ORDERED_ANALYTIC
OUT
OVER
OVERRIDE
PARAMETER
PARTITION
PARTITIONED
PASSWORD
PERCENT
PERCENT_RANK
PERM
PERMANENT
PRECEDING
PRIVATE
PROFILE
PROPORTIONAL
PROTECTED
PROTECTION
QUALIFIED
QUALIFY
QUANTILE
QUERY
RADIANS
RANDOM
RANDOMIZED
RANGE
RANGE_N
RANK
RECALC
REFERENCING
REGR_AVGX
REGR_AVGY
REGR_COUNT
REGR_INTERCEPT
REGR_R2
REGR_SLOPE
REGR_SXX
REGR_SXY
REGR_SYY
RELEASE
RENAME
REPEAT
REPLACE
REPLACEMENT
REPLICATION
REPOVERRIDE
REQUEST
RESTART
RESTORE
RESUME
RET
RETRIEVE
RETURNS
REUSE
REVALIDATE
RIGHTS
ROLE
ROLLFORWARD
ROLLUP
ROW
ROWID
ROW_NUMBER
SAMPLE
SAMPLEID
SAMPLES
SEARCHSPACE
SEL
SETRESRATE
SETS
SETSESSRATE
SHARE
SHOW
SIN
SINH
SKEW
SOUNDEX
SPECCHAR
SPECIFIC
SPOOL
SQLEXCEPTION
SQLTEXT
SQRT
SS
START
STARTUP
STAT
STATEMENT
STATISTICS
STATS
STDDEV_POP
STDDEV_SAMP
STEPINFO
STRING_CS
STYLE
SUBSCRIBER
SUBSTR
SUMMARY
SUSPEND
SYSTEM
SYSTEMTEST
TAN
TANH
TBL_CS
TD_GENERAL
TERMINATE
TEXT
THRESHOLD
TITLE
TPA
TRACE
TRANSLATE_CHK
TRIGGER
TYPE
UC
UNBOUNDED
UNDEFINED
UNDO
UNICODE
UNTIL
UPD
UPPERCASE
USE
VARBYTE
VARGRAPHIC
VAR_POP
VAR_SAMP
VOLATILE
WAIT
WHILE
WIDTH_BUCKET
WITHOUT
ZEROIFNULL
);

sub sql_keywords {
    return join ',', @Keywords;
}

sub sql_data_source_name {
    my $dbh = shift;
    return "dbi:$sql_driver:" . $dbh->{Name};
}

sub sql_server_name {
    my $dbh = shift;
    return $dbh->{Name};
}

sub sql_dbms_ver {
    my $dbh = shift;
    return $dbh->{tdat_version};
}

sub sql_charset {
    my $dbh = shift;
    return $dbh->{tdat_charset};
}

sub sql_user_name {
    my $dbh = shift;
    # CURRENT_USER is a non-standard attribute, probably undef
    # Username is a standard DBI attribute
    return $dbh->{CURRENT_USER} || $dbh->{Username};
}


our %info = (
     13 => \&sql_server_name,           	# SQL_SERVER_NAME
     18 => \&sql_dbms_ver,					# SQL_DBMS_VERSION
#
#	difficult to extract this wo executing a query
#
#     16 => 'DBITST',                      # SQL_DATABASE_NAME
#
#	only ODBC relevant
#
#     10 => '03.52.0000',                  # SQL_ODBC_VER
#    171 => '03.52.1022.0000',             # SQL_DM_VER

     20 => 'Y',                           # SQL_ACCESSIBLE_PROCEDURES
     19 => 'N',                           # SQL_ACCESSIBLE_TABLES
      0 => 0,                             # SQL_ACTIVE_CONNECTIONS
    116 => 0,                             # SQL_ACTIVE_ENVIRONMENTS
      1 => 16,                            # SQL_ACTIVE_STATEMENTS
    169 => 127,                           # SQL_AGGREGATE_FUNCTIONS
    117 => 0,                             # SQL_ALTER_DOMAIN
     86 => 3,                             # SQL_ALTER_TABLE
  10021 => 2,                             # SQL_ASYNC_MODE
    120 => 6,                             # SQL_BATCH_ROW_COUNT
    121 => 11,                            # SQL_BATCH_SUPPORT
     82 => 0,                             # SQL_BOOKMARK_PERSISTENCE
    114 => 0,                             # SQL_CATALOG_LOCATION
  10003 => 'N',                           # SQL_CATALOG_NAME
     41 => '',                            # SQL_CATALOG_NAME_SEPARATOR
     42 => '',                            # SQL_CATALOG_TERM
     92 => 0,                             # SQL_CATALOG_USAGE
#
#	probably should lookup our charset
#
  10004 => \&sql_charset,                 # SQL_COLLATING_SEQUENCE
     87 => 'Y',                           # SQL_COLUMN_ALIAS
     22 => 0,                             # SQL_CONCAT_NULL_BEHAVIOR
     53 => 0,                             # SQL_CONVERT_BIGINT
     54 => 265217,                        # SQL_CONVERT_BINARY
     55 => 12569,                         # SQL_CONVERT_BIT
     56 => 1832891,                       # SQL_CONVERT_CHAR
     57 => 33033,                         # SQL_CONVERT_DATE
     58 => 1581503,                       # SQL_CONVERT_DECIMAL
     59 => 8639,                          # SQL_CONVERT_DOUBLE
     60 => 8639,                          # SQL_CONVERT_FLOAT
     48 => 1,                             # SQL_CONVERT_FUNCTIONS
    173 => '-1',                          # SQL_CONVERT_GUID
     61 => 1679807,                       # SQL_CONVERT_INTEGER
    123 => 1073951,                       # SQL_CONVERT_INTERVAL_DAY_TIME
    124 => 549663,                        # SQL_CONVERT_INTERVAL_YEAR_MONTH
     71 => 265217,                        # SQL_CONVERT_LONGVARBINARY
     62 => 1832891,                       # SQL_CONVERT_LONGVARCHAR
     63 => 1581503,                       # SQL_CONVERT_NUMERIC
     64 => 8639,                          # SQL_CONVERT_REAL
     65 => 1581503,                       # SQL_CONVERT_SMALLINT
     66 => 65961,                         # SQL_CONVERT_TIME
     67 => 230145,                        # SQL_CONVERT_TIMESTAMP
     68 => 1581503,                       # SQL_CONVERT_TINYINT
     69 => 265217,                        # SQL_CONVERT_VARBINARY
     70 => 1832891,                       # SQL_CONVERT_VARCHAR
    122 => '-1',                          # SQL_CONVERT_WCHAR
    125 => '-1',                          # SQL_CONVERT_WLONGVARCHAR
    126 => '-1',                          # SQL_CONVERT_WVARCHAR
     74 => 1,                             # SQL_CORRELATION_NAME
    127 => 0,                             # SQL_CREATE_ASSERTION
    128 => 0,                             # SQL_CREATE_CHARACTER_SET
    129 => 0,                             # SQL_CREATE_COLLATION
    130 => 0,                             # SQL_CREATE_DOMAIN
    131 => 7,                             # SQL_CREATE_SCHEMA
    132 => '-1',                          # SQL_CREATE_TABLE
    133 => 0,                             # SQL_CREATE_TRANSLATION
    134 => 3,                             # SQL_CREATE_VIEW
     23 => 2,                             # SQL_CURSOR_COMMIT_BEHAVIOR
     24 => 2,                             # SQL_CURSOR_ROLLBACK_BEHAVIOR
  10001 => 1,                             # SQL_CURSOR_SENSITIVITY

      2 => \&sql_data_source_name,        # SQL_DATA_SOURCE_NAME
     25 => 'N',                           # SQL_DATA_SOURCE_READ_ONLY
    119 => 65535,                         # SQL_DATETIME_LITERALS
     17 => 'Teradata',                    # SQL_DBMS_NAME
    170 => 3,                             # SQL_DDL_INDEX
     26 => 8,                             # SQL_DEFAULT_TRANSACTION_ISOLATION
     26 => 8,                             # SQL_DEFAULT_TXN_ISOLATION
  10002 => '-256',                        # SQL_DESCRIBE_PARAMETER
      3 => 1,                             # SQL_DRIVER_HDBC
#   135 => undef,                         # SQL_DRIVER_HDESC
      4 => 1,                             # SQL_DRIVER_HENV
#    76 => undef,                         # SQL_DRIVER_HLIB
#     5 => undef,                         # SQL_DRIVER_HSTMT
      6 => $INC{'DBD/Teradata.pm'},       # SQL_DRIVER_NAME
     77 => '03.52',                       # SQL_DRIVER_ODBC_VER
      7 => $sql_driver_ver,               # SQL_DRIVER_VER
    136 => 0,                             # SQL_DROP_ASSERTION
    137 => 0,                             # SQL_DROP_CHARACTER_SET
    138 => 0,                             # SQL_DROP_COLLATION
    139 => 0,                             # SQL_DROP_DOMAIN
    140 => 0,                             # SQL_DROP_SCHEMA
    141 => '-1',                          # SQL_DROP_TABLE
    142 => 0,                             # SQL_DROP_TRANSLATION
    143 => '-1',                          # SQL_DROP_VIEW
    144 => 0,                             # SQL_DYNAMIC_CURSOR_ATTRIBUTES1
    145 => 0,                             # SQL_DYNAMIC_CURSOR_ATTRIBUTES2
     27 => 'Y',                           # SQL_EXPRESSIONS_IN_ORDERBY
      8 => 1,                             # SQL_FETCH_DIRECTION
     84 => 0,                             # SQL_FILE_USAGE
    146 => 0,                             # SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1
    147 => 0,                             # SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2
     81 => 11,                            # SQL_GETDATA_EXTENSIONS
     88 => 2,                             # SQL_GROUP_BY
     28 => 4,                             # SQL_IDENTIFIER_CASE
     29 => '"',                           # SQL_IDENTIFIER_QUOTE_CHAR
    148 => '-1',                          # SQL_INDEX_KEYWORDS
    149 => 0,                             # SQL_INFO_SCHEMA_VIEWS
    172 => '-1',                          # SQL_INSERT_STATEMENT
     73 => 'Y',                           # SQL_INTEGRITY
    150 => 0,                             # SQL_KEYSET_CURSOR_ATTRIBUTES1
    151 => 0,                             # SQL_KEYSET_CURSOR_ATTRIBUTES2
     89 => \&sql_keywords,                # SQL_KEYWORDS
    113 => 'Y',                           # SQL_LIKE_ESCAPE_CLAUSE
     78 => 1,                             # SQL_LOCK_TYPES
     34 => 0,                             # SQL_MAXIMUM_CATALOG_NAME_LENGTH
     97 => 0,                             # SQL_MAXIMUM_COLUMNS_IN_GROUP_BY
     98 => 64,                            # SQL_MAXIMUM_COLUMNS_IN_INDEX
     99 => 0,                             # SQL_MAXIMUM_COLUMNS_IN_ORDER_BY
    100 => 2048,                          # SQL_MAXIMUM_COLUMNS_IN_SELECT
    101 => 2048,                          # SQL_MAXIMUM_COLUMNS_IN_TABLE
     30 => 30,                            # SQL_MAXIMUM_COLUMN_NAME_LENGTH
      1 => 16,                            # SQL_MAXIMUM_CONCURRENT_ACTIVITIES
     31 => 30,                            # SQL_MAXIMUM_CURSOR_NAME_LENGTH
      0 => 0,                             # SQL_MAXIMUM_DRIVER_CONNECTIONS
  10005 => 30,                            # SQL_MAXIMUM_IDENTIFIER_LENGTH
    102 => 0,                             # SQL_MAXIMUM_INDEX_SIZE
    104 => '-1280',                       # SQL_MAXIMUM_ROW_SIZE
     32 => 30,                            # SQL_MAXIMUM_SCHEMA_NAME_LENGTH
    105 => 1047500,                       # SQL_MAXIMUM_STATEMENT_LENGTH
  20000 => '-1',                          # SQL_MAXIMUM_STMT_OCTETS
  20001 => '-1',                          # SQL_MAXIMUM_STMT_OCTETS_DATA
  20002 => '-1',                          # SQL_MAXIMUM_STMT_OCTETS_SCHEMA
    106 => 0,                             # SQL_MAXIMUM_TABLES_IN_SELECT
     35 => 30,                            # SQL_MAXIMUM_TABLE_NAME_LENGTH
    107 => 30,                            # SQL_MAXIMUM_USER_NAME_LENGTH
  10022 => '-1',                          # SQL_MAX_ASYNC_CONCURRENT_STATEMENTS
    112 => 62000,                         # SQL_MAX_BINARY_LITERAL_LEN
     34 => 0,                             # SQL_MAX_CATALOG_NAME_LEN
    108 => 31000,                         # SQL_MAX_CHAR_LITERAL_LEN
     97 => 0,                             # SQL_MAX_COLUMNS_IN_GROUP_BY
     98 => 64,                            # SQL_MAX_COLUMNS_IN_INDEX
     99 => 0,                             # SQL_MAX_COLUMNS_IN_ORDER_BY
    100 => 2048,                          # SQL_MAX_COLUMNS_IN_SELECT
    101 => 2048,                          # SQL_MAX_COLUMNS_IN_TABLE
     30 => 30,                            # SQL_MAX_COLUMN_NAME_LEN
      1 => 16,                            # SQL_MAX_CONCURRENT_ACTIVITIES
     31 => 30,                            # SQL_MAX_CURSOR_NAME_LEN
      0 => 0,                             # SQL_MAX_DRIVER_CONNECTIONS
  10005 => 30,                            # SQL_MAX_IDENTIFIER_LEN
    102 => 0,                             # SQL_MAX_INDEX_SIZE
     32 => 30,                            # SQL_MAX_OWNER_NAME_LEN
     33 => 30,                            # SQL_MAX_PROCEDURE_NAME_LEN
     34 => 0,                             # SQL_MAX_QUALIFIER_NAME_LEN
    104 => '-1280',                       # SQL_MAX_ROW_SIZE
    103 => '',                            # SQL_MAX_ROW_SIZE_INCLUDES_LONG
     32 => 30,                            # SQL_MAX_SCHEMA_NAME_LEN
    105 => 1047500,                       # SQL_MAX_STATEMENT_LEN
    106 => 0,                             # SQL_MAX_TABLES_IN_SELECT
     35 => 30,                            # SQL_MAX_TABLE_NAME_LEN
    107 => 30,                            # SQL_MAX_USER_NAME_LEN
     37 => 'Y',                           # SQL_MULTIPLE_ACTIVE_TXN
     36 => 'Y',                           # SQL_MULT_RESULT_SETS
    111 => 'N',                           # SQL_NEED_LONG_DATA_LEN
     75 => 1,                             # SQL_NON_NULLABLE_COLUMNS
     85 => 1,                             # SQL_NULL_COLLATION
     49 => 85249,                         # SQL_NUMERIC_FUNCTIONS
      9 => 2,                             # SQL_ODBC_API_CONFORMANCE
    152 => 1,                             # SQL_ODBC_INTERFACE_CONFORMANCE
     12 => 1,                             # SQL_ODBC_SAG_CLI_CONFORMANCE
     15 => 1,                             # SQL_ODBC_SQL_CONFORMANCE
     73 => 'Y',                           # SQL_ODBC_SQL_OPT_IEF
    115 => 127,                           # SQL_OJ_CAPABILITIES
     90 => 'N',                           # SQL_ORDER_BY_COLUMNS_IN_SELECT
     38 => 'Y',                           # SQL_OUTER_JOINS
    115 => 127,                           # SQL_OUTER_JOIN_CAPABILITIES
     39 => 'DATABASE',                    # SQL_OWNER_TERM
     91 => 31,                            # SQL_OWNER_USAGE
    153 => 2,                             # SQL_PARAM_ARRAY_ROW_COUNTS
    154 => 2,                             # SQL_PARAM_ARRAY_SELECTS
     80 => 0,                             # SQL_POSITIONED_STATEMENTS
     79 => 1,                             # SQL_POS_OPERATIONS
     21 => 'Y',                           # SQL_PROCEDURES
     40 => 'MACRO|PROCEDURE',             # SQL_PROCEDURE_TERM
    114 => 0,                             # SQL_QUALIFIER_LOCATION
     41 => '',                            # SQL_QUALIFIER_NAME_SEPARATOR
     42 => '',                            # SQL_QUALIFIER_TERM
     92 => 0,                             # SQL_QUALIFIER_USAGE
     93 => 4,                             # SQL_QUOTED_IDENTIFIER_CASE
     11 => 'N',                           # SQL_ROW_UPDATES
     39 => 'DATABASE',                    # SQL_SCHEMA_TERM
     91 => 31,                            # SQL_SCHEMA_USAGE
     43 => 3,                             # SQL_SCROLL_CONCURRENCY
     44 => 1,                             # SQL_SCROLL_OPTIONS
     14 => '\\',                          # SQL_SEARCH_PATTERN_ESCAPE
     94 => '#$',                          # SQL_SPECIAL_CHARACTERS
    155 => 7,                             # SQL_SQL92_DATETIME_FUNCTIONS
    156 => 0,                             # SQL_SQL92_FOREIGN_KEY_DELETE_RULE
    157 => 0,                             # SQL_SQL92_FOREIGN_KEY_UPDATE_RULE
    158 => '-1',                          # SQL_SQL92_GRANT
    159 => 63,                            # SQL_SQL92_NUMERIC_VALUE_FUNCTIONS
    160 => '-1',                          # SQL_SQL92_PREDICATES
    161 => '-1',                          # SQL_SQL92_RELATIONAL_JOIN_OPERATORS
    162 => 32144,                         # SQL_SQL92_REVOKE
    163 => 0,                             # SQL_SQL92_ROW_VALUE_CONSTRUCTOR
    164 => '-1',                          # SQL_SQL92_STRING_FUNCTIONS
    165 => 15,                            # SQL_SQL92_VALUE_EXPRESSIONS
    118 => '-1',                          # SQL_SQL_CONFORMANCE
    166 => 2,                             # SQL_STANDARD_CLI_CONFORMANCE
    167 => 0,                             # SQL_STATIC_CURSOR_ATTRIBUTES1
    168 => 0,                             # SQL_STATIC_CURSOR_ATTRIBUTES2
     83 => 0,                             # SQL_STATIC_SENSITIVITY
     50 => 7229,                          # SQL_STRING_FUNCTIONS
     95 => 23,                            # SQL_SUBQUERIES
     51 => 1,                             # SQL_SYSTEM_FUNCTIONS
     45 => 'TABLE',                       # SQL_TABLE_TERM
    109 => 351,                           # SQL_TIMEDATE_ADD_INTERVALS
    110 => 350,                           # SQL_TIMEDATE_DIFF_INTERVALS
     52 => 2064383,                       # SQL_TIMEDATE_FUNCTIONS
     46 => 1,                             # SQL_TRANSACTION_CAPABLE
     72 => 9,                             # SQL_TRANSACTION_ISOLATION_OPTION
     46 => 1,                             # SQL_TXN_CAPABLE
     72 => 9,                             # SQL_TXN_ISOLATION_OPTION
     96 => 3,                             # SQL_UNION
     96 => 3,                             # SQL_UNION_STATEMENT
     47 => \&sql_user_name,               # SQL_USER_NAME
  10000 => '-256',                        # SQL_XOPEN_CLI_YEAR
);

1;
