#
#    DBD::Teradata = Perl DBI Driver for Teradata
#    Copyright (C) 2001-2009, Presicient Corp., USA
#    email: info@presicient.com
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program; Refer to the included LICENSE file, or the LICENSE section 
#    of the DBD::Teradata documentation, for details. If neither is available,
#    write to the Free Software Foundation, Inc.,
#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

# The %type_info_all hash was automatically generated by
# DBI::DBD::Metadata::write_typeinfo_pm v1.05.

package DBD::Teradata::TypeInfo;

require Exporter;
require DynaLoader;
our @ISA = qw(Exporter DynaLoader);
our @EXPORT = qw(type_info_all);
use DBI qw(:sql_types);

our $type_info_all = [
        {
            TYPE_NAME          =>  0,
            DATA_TYPE          =>  1,
            COLUMN_SIZE        =>  2,
            LITERAL_PREFIX     =>  3,
            LITERAL_SUFFIX     =>  4,
            CREATE_PARAMS      =>  5,
            NULLABLE           =>  6,
            CASE_SENSITIVE     =>  7,
            SEARCHABLE         =>  8,
            UNSIGNED_ATTRIBUTE =>  9,
            FIXED_PREC_SCALE   => 10,
            AUTO_UNIQUE_VALUE  => 11,
            LOCAL_TYPE_NAME    => 12,
            MINIMUM_SCALE      => 13,
            MAXIMUM_SCALE      => 14,
            SQL_DATA_TYPE      => 15,
            SQL_DATETIME_SUB   => 16,
            NUM_PREC_RADIX     => 17,
            INTERVAL_PRECISION => 18,
        },
        [ "BYTEINT",                  SQL_TINYINT,                  3,    undef,        undef,               undef,             1,0,2,0,    0,0,"BYTEINT",                  0,    0,    SQL_TINYINT,  undef,10,undef, ],
        [ "VARBYTE",                  SQL_VARBINARY,                64000,"'",          "'XB",               "max length",      1,0,0,undef,0,0,"VARBYTE",                  undef,undef,SQL_VARBINARY,undef,0, undef, ],
        [ "BYTE",                     SQL_BINARY,                   64000,"'",          "'XB",               "max length",      1,0,0,undef,0,0,"BYTE",                     undef,undef,SQL_BINARY,   undef,0, undef, ],
        [ "CHAR",                     SQL_CHAR,                     64000,"'",          "'",                 "max length",      1,1,3,undef,0,0,"CHAR",                     undef,undef,SQL_CHAR,     undef,0, undef, ],
        [ "DECIMAL",                  SQL_DECIMAL,                  18,   undef,        undef,               "precision, scale",1,0,2,0,    0,0,"DECIMAL",                  0,    18,   SQL_DECIMAL,  undef,10,undef, ],
        [ "INTEGER",                  SQL_INTEGER,                  10,   undef,        undef,               undef,             1,0,2,0,    0,0,"INTEGER",                  0,    0,    SQL_INTEGER,  undef,10,undef, ],
        [ "SMALLINT",                 SQL_SMALLINT,                 5,    undef,        undef,               undef,             1,0,2,0,    0,0,"SMALLINT",                 0,    0,    SQL_SMALLINT, undef,10,undef, ],
        [ "FLOAT",                    SQL_FLOAT,                    15,   undef,        undef,               undef,             1,0,2,0,    0,0,"FLOAT",                    undef,undef,SQL_FLOAT,    undef,2, undef, ],
        [ "DATE",                     SQL_TYPE_DATE,                10,   undef,        undef,               undef,             1,0,2,undef,0,0,"DATE",                     0,    0,    SQL_DATE,     1,    0, undef, ],
        [ "TIME",                     SQL_TYPE_TIME,                8,    undef,        undef,               undef,             1,0,2,undef,0,0,"TIME",                     0,    0,    SQL_DATE,     2,    0, undef, ],
        [ "TIMESTAMP",                SQL_TYPE_TIMESTAMP,           26,   "TIMESTAMP '","'",                 "scale",           1,0,2,undef,0,0,"TIMESTAMP",                0,    6,    SQL_DATE,     3,    0, undef, ],
        [ "VARCHAR",                  SQL_VARCHAR,                  64000,"'",          "'",                 "max length",      1,1,3,undef,0,0,"VARCHAR",                  undef,undef,SQL_VARCHAR,  undef,0, undef, ],
        [ "INTERVAL YEAR",            SQL_INTERVAL_YEAR,            4,    "INTERVAL '", "' YEAR",            "precision",       1,0,2,undef,0,0,"INTERVAL YEAR",            undef,undef,SQL_TIME,     1,    0, 2,     ],
        [ "INTERVAL MONTH",           SQL_INTERVAL_MONTH,           4,    "INTERVAL '", "' MONTH",           "precision",       1,0,2,undef,0,0,"INTERVAL MONTH",           undef,undef,SQL_TIME,     2,    0, 2,     ],
        [ "INTERVAL DAY",             SQL_INTERVAL_DAY,             4,    "INTERVAL '", "' DAY",             "precision",       1,0,2,undef,0,0,"INTERVAL DAY",             undef,undef,SQL_TIME,     3,    0, 2,     ],
        [ "INTERVAL HOUR",            SQL_INTERVAL_HOUR,            4,    "INTERVAL '", "' HOUR",            "precision",       1,0,2,undef,0,0,"INTERVAL HOUR",            undef,undef,SQL_TIME,     4,    0, 2,     ],
        [ "INTERVAL MINUTE",          SQL_INTERVAL_MINUTE,          4,    "INTERVAL '", "' MINUTE",          "precision",       1,0,2,undef,0,0,"INTERVAL MINUTE",          undef,undef,SQL_TIME,     5,    0, 2,     ],
        [ "INTERVAL SECOND",          SQL_INTERVAL_SECOND,          11,   "INTERVAL '", "' SECOND",          "precision, scale",1,0,2,undef,0,0,"INTERVAL SECOND",          0,    6,    SQL_TIME,     6,    0, 2,     ],
        [ "INTERVAL YEAR TO MONTH",   SQL_INTERVAL_YEAR_TO_MONTH,   7,    "INTERVAL '", "' YEAR TO MONTH",   "precision",       1,0,2,undef,0,0,"INTERVAL YEAR TO MONTH",   undef,undef,SQL_TIME,     7,    0, 2,     ],
        [ "INTERVAL DAY TO HOUR",     SQL_INTERVAL_DAY_TO_HOUR,     7,    "INTERVAL '", "' DAY TO HOUR",     "precision",       1,0,2,undef,0,0,"INTERVAL DAY TO HOUR",     undef,undef,SQL_TIME,     8,    0, 2,     ],
        [ "INTERVAL DAY TO MINUTE",   SQL_INTERVAL_DAY_TO_MINUTE,   10,   "INTERVAL '", "' DAY TO MINUTE",   "precision",       1,0,2,undef,0,0,"INTERVAL DAY TO MINUTE",   undef,undef,SQL_TIME,     9,    0, 2,     ],
        [ "INTERVAL DAY TO SECOND",   SQL_INTERVAL_DAY_TO_SECOND,   20,   "INTERVAL '", "' DAY TO SECOND",   "precision",       1,0,2,undef,0,0,"INTERVAL DAY TO SECOND",   0,    6,    SQL_TIME,     10,   0, 2,     ],
        [ "INTERVAL HOUR TO MINUTE",  SQL_INTERVAL_HOUR_TO_MINUTE,  7,    "INTERVAL '", "' HOUR TO MINUTE",  "precision",       1,0,2,undef,0,0,"INTERVAL HOUR TO MINUTE",  undef,undef,SQL_TIME,     11,   0, 2,     ],
        [ "INTERVAL HOUR TO SECOND",  SQL_INTERVAL_HOUR_TO_SECOND,  17,   "INTERVAL '", "' HOUR TO SECOND",  "precision",       1,0,2,undef,0,0,"INTERVAL HOUR TO SECOND",  0,    6,    SQL_TIME,     12,   0, 2,     ],
        [ "INTERVAL MINUTE TO SECOND",SQL_INTERVAL_MINUTE_TO_SECOND,14,   "INTERVAL '", "' MINUTE TO SECOND","precision",       1,0,2,undef,0,0,"INTERVAL MINUTE TO SECOND",0,    6,    SQL_TIME,     13,   0, 2,     ],
    ];

1;
